package DX::Step::Normal;

use DX::Class;

has actions => (is => 'ro', required => 1);

has depends_on => (is => 'ro', required => 1);

has alternative_step => (is => 'ro');

sub but_with_dependencies_on {
  my ($self, @deps) = @_;
  $self->but(depends_on => [ @{$self->depends_on}, @deps ]);
}

sub but_with_alternative_step {
  my ($self, $step) = @_;
  bless { %$self, alternative_step => $step }, ref($self);
}

sub apply_to {
  my ($self, $old_hyp) = @_;
  return ($self->_apply_to_hyp($old_hyp), $self->alternative_step);
}

sub _apply_to_hyp {
  my ($self, $old_hyp) = @_;
  return undef unless my $hyp = $old_hyp->with_actions(@{$self->actions});
  return $hyp->resolve_head_dependent_on($self->depends_on);
}

1;
